#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;
using namespace System::Drawing::Imaging;

#include "..\..\common\imagefilter.h"

namespace FilterTemplate {


	public ref class SettingsForm : public System::Windows::Forms::Form
	{

	public:
		filtersettings* FilterSetting;
		bool FilterCancelled, MouseButtonDown, init;
	private: System::Windows::Forms::CheckBox^  CheckBoxAlternate;
	public: 

	private: System::Windows::Forms::HScrollBar^  HScrollBarIterations;
	public: 


	public:
		SettingsForm(filtersettings* fs)
		{
			init = true;
			InitializeComponent();
			FilterSetting   = fs;
			FilterCancelled = true;
			CheckBoxAlternate->Checked = (FilterSetting->alternating == 1) ;
			HScrollBarIterations->Value = (FilterSetting->filtering_iterations_limit > 0) ? FilterSetting->filtering_iterations_limit - 1 : FilterSetting->filtering_iterations_limit;
			init = false;
			HScrollBarIterations_Scroll(nullptr, nullptr);
		}

	protected:
		~SettingsForm()
		{
			if (components)
			{
				delete components;
			}
		}


	private: 
		System::Windows::Forms::Button^			ButtonApply;
		System::Windows::Forms::Button^			ButtonCancel;
		System::Windows::Forms::Label^			LabelIterations;
		System::Windows::Forms::Label^			LabelInfo;
		System::ComponentModel::IContainer^		components;


	public: 
#pragma region Windows Form Designer generated code
		void InitializeComponent(void)
		{
			this->ButtonApply = (gcnew System::Windows::Forms::Button());
			this->ButtonCancel = (gcnew System::Windows::Forms::Button());
			this->LabelInfo = (gcnew System::Windows::Forms::Label());
			this->HScrollBarIterations = (gcnew System::Windows::Forms::HScrollBar());
			this->LabelIterations = (gcnew System::Windows::Forms::Label());
			this->CheckBoxAlternate = (gcnew System::Windows::Forms::CheckBox());
			this->SuspendLayout();
			// 
			// ButtonApply
			// 
			this->ButtonApply->Location = System::Drawing::Point(314, 10);
			this->ButtonApply->Name = L"ButtonApply";
			this->ButtonApply->Size = System::Drawing::Size(75, 23);
			this->ButtonApply->TabIndex = 2;
			this->ButtonApply->Text = L"Apply";
			this->ButtonApply->UseVisualStyleBackColor = true;
			this->ButtonApply->Click += gcnew System::EventHandler(this, &SettingsForm::ButtonApply_Click);
			// 
			// ButtonCancel
			// 
			this->ButtonCancel->Location = System::Drawing::Point(314, 39);
			this->ButtonCancel->Name = L"ButtonCancel";
			this->ButtonCancel->Size = System::Drawing::Size(75, 23);
			this->ButtonCancel->TabIndex = 3;
			this->ButtonCancel->Text = L"Cancel";
			this->ButtonCancel->UseVisualStyleBackColor = true;
			this->ButtonCancel->Click += gcnew System::EventHandler(this, &SettingsForm::ButtonCancel_Click);
			// 
			// LabelInfo
			// 
			this->LabelInfo->Location = System::Drawing::Point(12, 10);
			this->LabelInfo->Name = L"LabelInfo";
			this->LabelInfo->Size = System::Drawing::Size(296, 33);
			this->LabelInfo->TabIndex = 4;
			this->LabelInfo->Text = L"A csszka kzptl val balra hzsval az Erzi mrtke, jobbra hzsval pedig" 
				L" a Kiterjeds mrtke llthat be.";
			// 
			// HScrollBarIterations
			// 
			this->HScrollBarIterations->LargeChange = 1;
			this->HScrollBarIterations->Location = System::Drawing::Point(9, 74);
			this->HScrollBarIterations->Maximum = 24;
			this->HScrollBarIterations->Minimum = -25;
			this->HScrollBarIterations->Name = L"HScrollBarIterations";
			this->HScrollBarIterations->Size = System::Drawing::Size(380, 17);
			this->HScrollBarIterations->TabIndex = 6;
			this->HScrollBarIterations->Scroll += gcnew System::Windows::Forms::ScrollEventHandler(this, &SettingsForm::HScrollBarIterations_Scroll);
			// 
			// LabelIterations
			// 
			this->LabelIterations->AutoSize = true;
			this->LabelIterations->Location = System::Drawing::Point(12, 49);
			this->LabelIterations->Name = L"LabelIterations";
			this->LabelIterations->Size = System::Drawing::Size(93, 13);
			this->LabelIterations->TabIndex = 7;
			this->LabelIterations->Text = L"Aktulis bellts: ";
			// 
			// CheckBoxAlternate
			// 
			this->CheckBoxAlternate->AutoSize = true;
			this->CheckBoxAlternate->Location = System::Drawing::Point(9, 103);
			this->CheckBoxAlternate->Name = L"CheckBoxAlternate";
			this->CheckBoxAlternate->Size = System::Drawing::Size(134, 17);
			this->CheckBoxAlternate->TabIndex = 8;
			this->CheckBoxAlternate->Text = L"Vltakoz vgrehajts:";
			this->CheckBoxAlternate->UseVisualStyleBackColor = true;
			this->CheckBoxAlternate->CheckedChanged += gcnew System::EventHandler(this, &SettingsForm::CheckBoxAlternate_CheckedChanged);
			// 
			// SettingsForm
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->BackColor = System::Drawing::Color::Silver;
			this->ClientSize = System::Drawing::Size(395, 132);
			this->Controls->Add(this->CheckBoxAlternate);
			this->Controls->Add(this->LabelIterations);
			this->Controls->Add(this->HScrollBarIterations);
			this->Controls->Add(this->LabelInfo);
			this->Controls->Add(this->ButtonCancel);
			this->Controls->Add(this->ButtonApply);
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedSingle;
			this->MaximizeBox = false;
			this->MinimizeBox = false;
			this->Name = L"SettingsForm";
			this->ShowIcon = false;
			this->ShowInTaskbar = false;
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = L"Kiterjeds, Erzi (Dilation, Erosion)";
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion

	private: 
		void ButtonApply_Click(System::Object^  sender, System::EventArgs^  e) 
		{
			FilterCancelled = false;
			this->Close();
		}

		void ButtonCancel_Click(System::Object^  sender, System::EventArgs^  e) { this->Close(); }

		void HScrollBarIterations_Scroll(System::Object^  sender, System::Windows::Forms::ScrollEventArgs^  e) 
		{
			if (init) return;
			LabelIterations->Text = "Aktulis bellts: ";
			if (HScrollBarIterations->Value < 0)
			{
				LabelIterations->Text += "Erzi mrtke: " + (-HScrollBarIterations->Value).ToString() + " iterci";
				FilterSetting->filtering_iterations_limit = HScrollBarIterations->Value;
			}
			else
			{
				LabelIterations->Text += "Kiterjeds mrtke: " + (HScrollBarIterations->Value + 1).ToString() + " iterci";
				FilterSetting->filtering_iterations_limit = HScrollBarIterations->Value + 1;
			}
			CheckBoxAlternate_CheckedChanged(nullptr, nullptr);
		}

		void CheckBoxAlternate_CheckedChanged(System::Object^  sender, System::EventArgs^  e) 
		{
			if (init) return;
			String^ s = "Vltakoz vgrehajts: ";
			if (FilterSetting->filtering_iterations_limit < 0)
				s += "(Erzi->Kiterjeds) X " + (-FilterSetting->filtering_iterations_limit).ToString();
			else
				s += "(Kiterjeds->Erzi) X " + FilterSetting->filtering_iterations_limit.ToString();
			CheckBoxAlternate->Text = s;
			FilterSetting->alternating = (CheckBoxAlternate->Checked) ? 1 : 0;
		}
};
}
